//---------------------------------------------------------------------------
#ifndef MyBlowfishH
#define MyBlowfishH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------
#define BLOW_OK                 1
#define BLOW_FILE_NOT_FOUND     2
#define BLOW_ERR_READING_INPUT  3
#define BLOW_ERR_WRITING_OUTPUT 4
#define BLOW_NOT_IMPLEMENTED    5
#define BLOW_OUT_OF_MEMORY      6
#define BLOW_BUFF_SIZE_ERR      7
#define BLOW_FILE_NOT_CREATED   8

#define NUM_SUBKEYS  18
#define NUM_S_BOXES  4
#define NUM_ENTRIES  256
#define MAX_STRING   256
#define MAX_PASSWD   56  // 448bits
#define F(x)    (((SB[0][x.byte.zero] + SB[1][x.byte.one]) ^ SB[2][x.byte.two]) + SB[3][x.byte.three])
#define SIZEOF_BLOC 1024*65

struct WordByte
{
	unsigned int three:8;
	unsigned int two:8;
	unsigned int one:8;
	unsigned int zero:8;
};

union bWord
{
	unsigned int word;
	WordByte byte;
};

struct bDWord
{
	bWord word0;
	bWord word1;
};

class PACKAGE TMyBlowfish : public TComponent
{
private:
    unsigned int PA[NUM_SUBKEYS];
    unsigned int SB[NUM_S_BOXES][NUM_ENTRIES];
    AnsiString pass;
    bool bturbo;
    int CRC16_Table[256];

    void __fastcall Gen_Subkeys(void);
    void __fastcall BF_En(bWord *, bWord *);
    void __fastcall BF_De(bWord *, bWord *);
    void __fastcall Setpassword(AnsiString value);
    AnsiString __fastcall Getpassword(void);
    void __fastcall Reset(void);
    void __fastcall CRC16_Init(void);

    typedef void __fastcall (__closure *TOnProgressChange) (TObject *Sender, long &Total);
    TOnProgressChange FOnProgressChange;
    DYNAMIC void __fastcall ProgressChange(long p);

protected:

public:
    __fastcall TMyBlowfish(TComponent* Owner);
    unsigned char __fastcall Encrypt_Bin(void *, unsigned int);
    unsigned char __fastcall Decrypt_Bin(void *, unsigned int);
    unsigned char __fastcall Encrypt_File(char *);
    unsigned char __fastcall Decrypt_File(char *);
    int __fastcall CRC16_Calc(int crc, char *buf, unsigned nbytes);
    int __fastcall CRC16_File(char *fn);

__published:
    __property AnsiString Password  = {read=Getpassword, write=Setpassword };
    __property bool Turbo  = {read=bturbo, write=bturbo, default=false };
    __property TOnProgressChange OnProgressChange = {read = FOnProgressChange, write = FOnProgressChange};
};
//---------------------------------------------------------------------------
#endif
