//---------------------------------------------------------------------------
// TMyVersion V1.0 par BRUN Stephane 04/2003
// <brun.stephane@free.fr>
//
// Composant non graphique qui permet de connatre les informations de version
// stockes dans le fichier exe
//
// Voici les valeurs connues (AnsiString):
//  CompanyName
//  FileDescription
//  FileVersion
//  InternalName
//  LegalCopyright
//  OriginalFilename
//  ProductName
//  ProductVersion
//
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "MyVersion.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck est utilis est utilis pour tre sr que les composants crs n'ont
// aucune fonction virtuelle pure.
//

static inline void ValidCtrCheck(TMyVersion *)
{
    new TMyVersion(NULL);
}
//---------------------------------------------------------------------------
__fastcall TMyVersion::TMyVersion(TComponent* Owner)
    : TComponent(Owner)
{
    char *data ;
    UINT datasize ;
    struct
    {
        unsigned short language ;
        unsigned short character_set ;
    }*translation ;
    DWORD handle ;
    DWORD size;
    bool status;

    // Init des variables
    SFileVersion=SCompanyName=SFileDescription=SInternalName=SLegalCopyright=SOriginalFilename=SProductName=SProductVersion="##";

    size=GetFileVersionInfoSize(Application->ExeName.c_str(), &handle);
    if(size == 0)
        return ;

    char *buffer = new char [size] ;

    status=GetFileVersionInfo(
        Application->ExeName.c_str(),
        0,
        size,
        buffer) ;

    if(!status)
    {
        delete [] buffer ;
        return ;
    }

    // Extract the language ID
    VerQueryValue(
        buffer,
        "\\VarFileInfo\\Translation",
        (void **) &translation,
        &datasize);

    String key0 = "\\StringFileInfo\\" + String::IntToHex (translation [0].language, 4) + String::IntToHex (translation [0].character_set, 4);
    String key;

    // FileVersion
    key = key0 + "\\FileVersion" ;
    status = VerQueryValue(buffer, key.c_str (), (void **) &data, &datasize);
    if(status) SFileVersion = data;

    // CompanyName
    key = key0 + "\\CompanyName" ;
    status = VerQueryValue(buffer, key.c_str (), (void **) &data, &datasize);
    if(status) SCompanyName = data;

    // FileDescription
    key = key0 + "\\FileDescription" ;
    status = VerQueryValue(buffer, key.c_str (), (void **) &data, &datasize);
    if(status) SFileDescription = data;

    // InternalName
    key = key0 + "\\InternalName" ;
    status = VerQueryValue(buffer, key.c_str (), (void **) &data, &datasize);
    if(status) SInternalName = data;

    // LegalCopyright
    key = key0 + "\\LegalCopyright" ;
    status = VerQueryValue(buffer, key.c_str (), (void **) &data, &datasize);
    if(status) SLegalCopyright = data;

    // OriginalFilename
    key = key0 + "\\OriginalFilename" ;
    status = VerQueryValue(buffer, key.c_str (), (void **) &data, &datasize);
    if(status) SOriginalFilename = data;

    // ProductName
    key = key0 + "\\ProductName" ;
    status = VerQueryValue(buffer, key.c_str (), (void **) &data, &datasize);
    if(status) SProductName = data;

    // ProductVersion
    key = key0 + "\\ProductVersion" ;
    status = VerQueryValue(buffer, key.c_str (), (void **) &data, &datasize);
    if(status) SProductVersion = data;

    delete [] buffer ;

    return ;
}

//---------------------------------------------------------------------------
namespace Myversion
{
    void __fastcall PACKAGE Register()
    {
         TComponentClass classes[1] = {__classid(TMyVersion)};
         RegisterComponents("MyComp", classes, 0);
    }
}
//---------------------------------------------------------------------------
